Index: source/simulation2/components/CCmpPathfinder.cpp
===================================================================
--- source/simulation2/components/CCmpPathfinder.cpp	(revision 13108)
+++ source/simulation2/components/CCmpPathfinder.cpp	(working copy)
@@ -33,6 +33,7 @@
 #include "simulation2/components/ICmpObstructionManager.h"
 #include "simulation2/components/ICmpTerrain.h"
 #include "simulation2/components/ICmpWaterManager.h"
+#include "simulation2/helpers/Rasterize.h"
 #include "simulation2/serialization/SerializeTemplates.h"
 
 // Default cost to move a single tile is a fairly arbitrary number, which should be big
@@ -46,14 +47,17 @@
 {
 	m_MapSize = 0;
 	m_Grid = NULL;
-	m_ObstructionGrid = NULL;
+	m_ObstructionGridDirtyID = 0;
 	m_TerrainDirty = true;
 	m_NextAsyncTicket = 1;
 
 	m_DebugOverlay = NULL;
 	m_DebugGrid = NULL;
+	m_DebugGridJPS = NULL;
 	m_DebugPath = NULL;
 
+	PathfinderHierInit();
+
 	m_SameTurnMovesCount = 0;
 
 	// Since this is used as a system component (not loaded from an entity template),
@@ -86,65 +90,10 @@
 	{
 		std::string name = it->first;
 		ENSURE((int)m_PassClasses.size() <= PASS_CLASS_BITS);
-		pass_class_t mask = (pass_class_t)(1u << (m_PassClasses.size() + 2));
+		pass_class_t mask = PASS_CLASS_MASK_FROM_INDEX(m_PassClasses.size());
 		m_PassClasses.push_back(PathfinderPassability(mask, it->second));
 		m_PassClassMasks[name] = mask;
 	}
-
-
-	const CParamNode::ChildrenMap& moveClasses = externalParamNode.GetChild("Pathfinder").GetChild("MovementClasses").GetChildren();
-
-	// First find the set of unit classes used by any terrain classes,
-	// and assign unique tags to terrain classes
-	std::set<std::string> unitClassNames;
-	unitClassNames.insert("default"); // must always have costs for default
-
-	{
-		size_t i = 0;
-		for (CParamNode::ChildrenMap::const_iterator it = moveClasses.begin(); it != moveClasses.end(); ++it)
-		{
-			std::string terrainClassName = it->first;
-			m_TerrainCostClassTags[terrainClassName] = (cost_class_t)i;
-			++i;
-
-			const CParamNode::ChildrenMap& unitClasses = it->second.GetChild("UnitClasses").GetChildren();
-			for (CParamNode::ChildrenMap::const_iterator uit = unitClasses.begin(); uit != unitClasses.end(); ++uit)
-				unitClassNames.insert(uit->first);
-		}
-	}
-
-	// For each terrain class, set the costs for every unit class,
-	// and assign unique tags to unit classes
-	{
-		size_t i = 0;
-		for (std::set<std::string>::const_iterator nit = unitClassNames.begin(); nit != unitClassNames.end(); ++nit)
-		{
-			m_UnitCostClassTags[*nit] = (cost_class_t)i;
-			++i;
-
-			std::vector<u32> costs;
-			std::vector<fixed> speeds;
-
-			for (CParamNode::ChildrenMap::const_iterator it = moveClasses.begin(); it != moveClasses.end(); ++it)
-			{
-				// Default to the general costs for this terrain class
-				fixed cost = it->second.GetChild("@Cost").ToFixed();
-				fixed speed = it->second.GetChild("@Speed").ToFixed();
-				// Check for specific cost overrides for this unit class
-				const CParamNode& unitClass = it->second.GetChild("UnitClasses").GetChild(nit->c_str());
-				if (unitClass.IsOk())
-				{
-					cost = unitClass.GetChild("@Cost").ToFixed();
-					speed = unitClass.GetChild("@Speed").ToFixed();
-				}
-				costs.push_back((cost * DEFAULT_MOVE_COST).ToInt_RoundToZero());
-				speeds.push_back(speed);
-			}
-
-			m_MoveCosts.push_back(costs);
-			m_MoveSpeeds.push_back(speeds);
-		}
-	}
 }
 
 void CCmpPathfinder::Deinit()
@@ -152,8 +101,9 @@
 	SetDebugOverlay(false); // cleans up memory
 	ResetDebugPath();
 
-	delete m_Grid;
-	delete m_ObstructionGrid;
+	PathfinderHierDeinit();
+
+	SAFE_DELETE(m_Grid);
 }
 
 struct SerializeLongRequest
@@ -166,7 +116,6 @@
 		serialize.NumberFixed_Unbounded("z0", value.z0);
 		SerializeGoal()(serialize, "goal", value.goal);
 		serialize.NumberU16_Unbounded("pass class", value.passClass);
-		serialize.NumberU8_Unbounded("cost class", value.costClass);
 		serialize.NumberU32_Unbounded("notify", value.notify);
 	}
 };
@@ -235,19 +184,11 @@
 {
 	for (size_t i = 0; i < m_DebugOverlayShortPathLines.size(); ++i)
 		collector.Submit(&m_DebugOverlayShortPathLines[i]);
+
+	PathfinderHierRenderSubmit(collector);
 }
 
 
-fixed CCmpPathfinder::GetMovementSpeed(entity_pos_t x0, entity_pos_t z0, u8 costClass)
-{
-	UpdateGrid();
-
-	u16 i, j;
-	NearestTile(x0, z0, i, j);
-	TerrainTile tileTag = m_Grid->get(i, j);
-	return m_MoveSpeeds.at(costClass).at(GET_COST_CLASS(tileTag));
-}
-
 ICmpPathfinder::pass_class_t CCmpPathfinder::GetPassabilityClass(const std::string& name)
 {
 	if (m_PassClassMasks.find(name) == m_PassClassMasks.end())
@@ -264,277 +205,362 @@
 	return m_PassClassMasks;
 }
 
-ICmpPathfinder::cost_class_t CCmpPathfinder::GetCostClass(const std::string& name)
+const PathfinderPassability* CCmpPathfinder::GetPassabilityFromMask(pass_class_t passClass)
 {
-	if (m_UnitCostClassTags.find(name) == m_UnitCostClassTags.end())
-	{
-		LOGERROR(L"Invalid unit cost class name '%hs'", name.c_str());
-		return m_UnitCostClassTags["default"];
-	}
-
-	return m_UnitCostClassTags[name];
+	for (size_t i = 0; i < m_PassClasses.size(); ++i)
+		if (m_PassClasses[i].m_Mask == passClass)
+			return &m_PassClasses[i];
+	return NULL;
 }
 
-fixed CCmpPathfinder::DistanceToGoal(CFixedVector2D pos, const CCmpPathfinder::Goal& goal)
-{
-	switch (goal.type)
-	{
-	case CCmpPathfinder::Goal::POINT:
-		return (pos - CFixedVector2D(goal.x, goal.z)).Length();
-
-	case CCmpPathfinder::Goal::CIRCLE:
-		return ((pos - CFixedVector2D(goal.x, goal.z)).Length() - goal.hw).Absolute();
-
-	case CCmpPathfinder::Goal::SQUARE:
-	{
-		CFixedVector2D halfSize(goal.hw, goal.hh);
-		CFixedVector2D d(pos.X - goal.x, pos.Y - goal.z);
-		return Geometry::DistanceToSquare(d, goal.u, goal.v, halfSize);
-	}
-
-	default:
-		debug_warn(L"invalid type");
-		return fixed::Zero();
-	}
-}
-
 const Grid<u16>& CCmpPathfinder::GetPassabilityGrid()
 {
 	UpdateGrid();
 	return *m_Grid;
 }
 
-void CCmpPathfinder::UpdateGrid()
+/**
+ * Given a grid of passable/impassable navcells (based on some passability mask),
+ * computes a new grid where a navcell is impassable (per that mask) if
+ * it is <=clearance navcells away from an impassable navcell in the original grid.
+ * The results are ORed onto the original grid.
+ *
+ * This is used for adding clearance onto terrain-based navcell passability.
+ *
+ * TODO: might be nicer to get rounded corners by measuring clearances as
+ * Euclidean distances; currently it effectively does dist=max(dx,dy) instead.
+ */
+static void ExpandImpassableCells(Grid<u16>& grid, u16 clearance, ICmpPathfinder::pass_class_t mask)
 {
-	CmpPtr<ICmpTerrain> cmpTerrain(GetSimContext(), SYSTEM_ENTITY);
-	if (!cmpTerrain)
-		return; // error
+	PROFILE3("ExpandImpassableCells");
 
-	// If the terrain was resized then delete the old grid data
-	if (m_Grid && m_MapSize != cmpTerrain->GetTilesPerSide())
-	{
-		SAFE_DELETE(m_Grid);
-		SAFE_DELETE(m_ObstructionGrid);
-		m_TerrainDirty = true;
-	}
+	u16 w = grid.m_W;
+	u16 h = grid.m_H;
 
-	// Initialise the terrain data when first needed
-	if (!m_Grid)
+	// First expand impassable cells horizontally into a temporary 1-bit grid
+	Grid<u8> tempGrid(w, h);
+	for (u16 j = 0; j < h; ++j)
 	{
-		m_MapSize = cmpTerrain->GetTilesPerSide();
-		m_Grid = new Grid<TerrainTile>(m_MapSize, m_MapSize);
-		m_ObstructionGrid = new Grid<u8>(m_MapSize, m_MapSize);
-	}
+		// New cell (i,j) is blocked if (i',j) blocked for any i-clearance <= i' <= i+clearance
 
-	CmpPtr<ICmpObstructionManager> cmpObstructionManager(GetSimContext(), SYSTEM_ENTITY);
+		// Count the number of blocked cells around i=0
+		u16 numBlocked = 0;
+		for (u16 i = 0; i <= clearance && i < w; ++i)
+			if (!IS_PASSABLE(grid.get(i, j), mask))
+				++numBlocked;
 
-	bool obstructionsDirty = cmpObstructionManager->Rasterise(*m_ObstructionGrid);
+		for (u16 i = 0; i < w; ++i)
+		{
+			// Store a flag if blocked by at least one nearby cell
+			if (numBlocked)
+				tempGrid.set(i, j, 1);
 
-	if (obstructionsDirty && !m_TerrainDirty)
+			// Slide the numBlocked window along:
+			// remove the old i-clearance value, add the new (i+1)+clearance
+			// (avoiding overflowing the grid)
+			if (i >= clearance && !IS_PASSABLE(grid.get(i-clearance, j), mask))
+				--numBlocked;
+			if (i+1+clearance < w && !IS_PASSABLE(grid.get(i+1+clearance, j), mask))
+				++numBlocked;
+		}
+	}
+
+	for (u16 i = 0; i < w; ++i)
 	{
-		PROFILE("UpdateGrid obstructions");
+		// New cell (i,j) is blocked if (i,j') blocked for any j-clearance <= j' <= j+clearance
 
-		// Obstructions changed - we need to recompute passability
-		// Since terrain hasn't changed we only need to update the obstruction bits
-		// and can skip the rest of the data
+		// Count the number of blocked cells around j=0
+		u16 numBlocked = 0;
+		for (u16 j = 0; j <= clearance && j < h; ++j)
+			if (tempGrid.get(i, j))
+				++numBlocked;
 
-		// TODO: if ObstructionManager::SetPassabilityCircular was called at runtime
-		// (which should probably never happen, but that's not guaranteed),
-		// then TILE_OUTOFBOUNDS will change and we can't use this fast path, but
-		// currently it'll just set obstructionsDirty and we won't notice
-
-		for (u16 j = 0; j < m_MapSize; ++j)
+		for (u16 j = 0; j < h; ++j)
 		{
-			for (u16 i = 0; i < m_MapSize; ++i)
-			{
-				TerrainTile& t = m_Grid->get(i, j);
+			// Add the mask if blocked by at least one nearby cell
+			if (numBlocked)
+				grid.set(i, j, grid.get(i, j) | mask);
 
-				u8 obstruct = m_ObstructionGrid->get(i, j);
-
-				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING)
-					t |= 1;
-				else
-					t &= (TerrainTile)~1;
-
-				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_FOUNDATION)
-					t |= 2;
-				else
-					t &= (TerrainTile)~2;
-			}
+			// Slide the numBlocked window along:
+			// remove the old j-clearance value, add the new (j+1)+clearance
+			// (avoiding overflowing the grid)
+			if (j >= clearance && tempGrid.get(i, j-clearance))
+				--numBlocked;
+			if (j+1+clearance < h && tempGrid.get(i, j+1+clearance))
+				++numBlocked;
 		}
-
-		++m_Grid->m_DirtyID;
 	}
-	else if (obstructionsDirty || m_TerrainDirty)
-	{
-		PROFILE("UpdateGrid full");
+}
 
-		// Obstructions or terrain changed - we need to recompute passability
-		// TODO: only bother recomputing the region that has actually changed
+Grid<u16> CCmpPathfinder::ComputeShoreGrid()
+{
+	PROFILE3("ComputeShoreGrid");
 
-		CmpPtr<ICmpWaterManager> cmpWaterManager(GetSimContext(), SYSTEM_ENTITY);
+	CmpPtr<ICmpWaterManager> cmpWaterManager(GetSimContext(), SYSTEM_ENTITY);
 
-		// TOOD: these bits should come from ICmpTerrain
-		CTerrain& terrain = GetSimContext().GetTerrain();
+	// TOOD: these bits should come from ICmpTerrain
+	CTerrain& terrain = GetSimContext().GetTerrain();
 
-		// avoid integer overflow in intermediate calculation
-		const u16 shoreMax = 32767;
-		
-		// First pass - find underwater tiles
-		Grid<bool> waterGrid(m_MapSize, m_MapSize);
-		for (u16 j = 0; j < m_MapSize; ++j)
+	// avoid integer overflow in intermediate calculation
+	const u16 shoreMax = 32767;
+
+	// First pass - find underwater tiles
+	Grid<u8> waterGrid(m_MapSize, m_MapSize);
+	for (u16 j = 0; j < m_MapSize; ++j)
+	{
+		for (u16 i = 0; i < m_MapSize; ++i)
 		{
-			for (u16 i = 0; i < m_MapSize; ++i)
-			{
-				fixed x, z;
-				TileCenter(i, j, x, z);
-				
-				bool underWater = cmpWaterManager && (cmpWaterManager->GetWaterLevel(x, z) > terrain.GetExactGroundLevelFixed(x, z));
-				waterGrid.set(i, j, underWater);
-			}
+			fixed x, z;
+			TileCenter(i, j, x, z);
+
+			bool underWater = cmpWaterManager && (cmpWaterManager->GetWaterLevel(x, z) > terrain.GetExactGroundLevelFixed(x, z));
+			waterGrid.set(i, j, underWater ? 1 : 0);
 		}
-		// Second pass - find shore tiles
-		Grid<u16> shoreGrid(m_MapSize, m_MapSize);
-		for (u16 j = 0; j < m_MapSize; ++j)
+	}
+
+	// Second pass - find shore tiles
+	Grid<u16> shoreGrid(m_MapSize, m_MapSize);
+	for (u16 j = 0; j < m_MapSize; ++j)
+	{
+		for (u16 i = 0; i < m_MapSize; ++i)
 		{
-			for (u16 i = 0; i < m_MapSize; ++i)
+			// Find a land tile
+			if (!waterGrid.get(i, j))
 			{
-				// Find a land tile
-				if (!waterGrid.get(i, j))
+				if ((i > 0 && waterGrid.get(i-1, j)) || (i > 0 && j < m_MapSize-1 && waterGrid.get(i-1, j+1)) || (i > 0 && j > 0 && waterGrid.get(i-1, j-1))
+					|| (i < m_MapSize-1 && waterGrid.get(i+1, j)) || (i < m_MapSize-1 && j < m_MapSize-1 && waterGrid.get(i+1, j+1)) || (i < m_MapSize-1 && j > 0 && waterGrid.get(i+1, j-1))
+					|| (j > 0 && waterGrid.get(i, j-1)) || (j < m_MapSize-1 && waterGrid.get(i, j+1))
+					)
+				{	// If it's bordered by water, it's a shore tile
+					shoreGrid.set(i, j, 0);
+				}
+				else
 				{
-					if ((i > 0 && waterGrid.get(i-1, j)) || (i > 0 && j < m_MapSize-1 && waterGrid.get(i-1, j+1)) || (i > 0 && j > 0 && waterGrid.get(i-1, j-1))
-						|| (i < m_MapSize-1 && waterGrid.get(i+1, j)) || (i < m_MapSize-1 && j < m_MapSize-1 && waterGrid.get(i+1, j+1)) || (i < m_MapSize-1 && j > 0 && waterGrid.get(i+1, j-1))
-						|| (j > 0 && waterGrid.get(i, j-1)) || (j < m_MapSize-1 && waterGrid.get(i, j+1))
-						)
-					{	// If it's bordered by water, it's a shore tile
-						shoreGrid.set(i, j, 0);
-					}
-					else
-					{
-						shoreGrid.set(i, j, shoreMax);
-					}
+					shoreGrid.set(i, j, shoreMax);
 				}
 			}
 		}
+	}
 
-		// Expand influences on land to find shore distance
-		for (u16 y = 0; y < m_MapSize; ++y)
+	// Expand influences on land to find shore distance
+	for (u16 y = 0; y < m_MapSize; ++y)
+	{
+		u16 min = shoreMax;
+		for (u16 x = 0; x < m_MapSize; ++x)
 		{
-			u16 min = shoreMax;
-			for (u16 x = 0; x < m_MapSize; ++x)
+			if (!waterGrid.get(x, y))
 			{
-				if (!waterGrid.get(x, y))
-				{
-					u16 g = shoreGrid.get(x, y);
-					if (g > min)
-						shoreGrid.set(x, y, min);
-					else if (g < min)
-						min = g;
+				u16 g = shoreGrid.get(x, y);
+				if (g > min)
+					shoreGrid.set(x, y, min);
+				else if (g < min)
+					min = g;
 
-					++min;
-				}
+				++min;
 			}
-			for (u16 x = m_MapSize; x > 0; --x)
+		}
+		for (u16 x = m_MapSize; x > 0; --x)
+		{
+			if (!waterGrid.get(x-1, y))
 			{
-				if (!waterGrid.get(x-1, y))
-				{
-					u16 g = shoreGrid.get(x-1, y);
-					if (g > min)
-						shoreGrid.set(x-1, y, min);
-					else if (g < min)
-						min = g;
+				u16 g = shoreGrid.get(x-1, y);
+				if (g > min)
+					shoreGrid.set(x-1, y, min);
+				else if (g < min)
+					min = g;
 
-					++min;
-				}
+				++min;
 			}
 		}
-		for (u16 x = 0; x < m_MapSize; ++x)
+	}
+	for (u16 x = 0; x < m_MapSize; ++x)
+	{
+		u16 min = shoreMax;
+		for (u16 y = 0; y < m_MapSize; ++y)
 		{
-			u16 min = shoreMax;
-			for (u16 y = 0; y < m_MapSize; ++y)
+			if (!waterGrid.get(x, y))
 			{
-				if (!waterGrid.get(x, y))
-				{
-					u16 g = shoreGrid.get(x, y);
-					if (g > min)
-						shoreGrid.set(x, y, min);
-					else if (g < min)
-						min = g;
+				u16 g = shoreGrid.get(x, y);
+				if (g > min)
+					shoreGrid.set(x, y, min);
+				else if (g < min)
+					min = g;
 
-					++min;
-				}
+				++min;
 			}
-			for (u16 y = m_MapSize; y > 0; --y)
+		}
+		for (u16 y = m_MapSize; y > 0; --y)
+		{
+			if (!waterGrid.get(x, y-1))
 			{
-				if (!waterGrid.get(x, y-1))
-				{
-					u16 g = shoreGrid.get(x, y-1);
-					if (g > min)
-						shoreGrid.set(x, y-1, min);
-					else if (g < min)
-						min = g;
+				u16 g = shoreGrid.get(x, y-1);
+				if (g > min)
+					shoreGrid.set(x, y-1, min);
+				else if (g < min)
+					min = g;
 
-					++min;
-				}
+				++min;
 			}
 		}
+	}
 
-		// Apply passability classes to terrain
-		for (u16 j = 0; j < m_MapSize; ++j)
+	return shoreGrid;
+}
+
+void CCmpPathfinder::ComputeTerrainPassabilityGrid(const Grid<u16>& shoreGrid)
+{
+	PROFILE3("terrain passability");
+
+	CmpPtr<ICmpWaterManager> cmpWaterManager(GetSimContext(), SYSTEM_ENTITY);
+
+	CTerrain& terrain = GetSimContext().GetTerrain();
+
+	// Compute initial terrain-dependent passability
+	for (int j = 0; j < m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE; ++j)
+	{
+		for (int i = 0; i < m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE; ++i)
 		{
-			for (u16 i = 0; i < m_MapSize; ++i)
+			// World-space coordinates for this navcell
+			fixed x, z;
+			NavcellCenter(i, j, x, z);
+
+			// Terrain-tile coordinates for this navcell
+			int itile = i / ICmpObstructionManager::NAVCELLS_PER_TILE;
+			int jtile = j / ICmpObstructionManager::NAVCELLS_PER_TILE;
+
+			// Gather all the data potentially needed to determine passability:
+
+			fixed height = terrain.GetExactGroundLevelFixed(x, z);
+
+			fixed water;
+			if (cmpWaterManager)
+				water = cmpWaterManager->GetWaterLevel(x, z);
+
+			fixed depth = water - height;
+
+			//fixed slope = terrain.GetExactSlopeFixed(x, z);
+			// Exact slopes give kind of weird output, so just use rough tile-based slopes
+			fixed slope = terrain.GetSlopeFixed(itile, jtile);
+
+			// Get world-space coordinates from shoreGrid (which uses terrain tiles)
+			fixed shoredist = fixed::FromInt(shoreGrid.get(itile, jtile)) * (int)TERRAIN_TILE_SIZE;
+
+			// Compute the passability for every class for this cell:
+
+			NavcellData t = 0;
+			for (size_t n = 0; n < m_PassClasses.size(); ++n)
 			{
-				fixed x, z;
-				TileCenter(i, j, x, z);
+				if (!m_PassClasses[n].IsPassable(depth, slope, shoredist))
+					t |= m_PassClasses[n].m_Mask;
+			}
 
-				TerrainTile t = 0;
+			m_Grid->set(i, j, t);
+		}
+	}
+}
 
-				u8 obstruct = m_ObstructionGrid->get(i, j);
+void CCmpPathfinder::UpdateGrid()
+{
+	CmpPtr<ICmpTerrain> cmpTerrain(GetSimContext(), SYSTEM_ENTITY);
+	if (!cmpTerrain)
+		return; // error
 
-				fixed height = terrain.GetExactGroundLevelFixed(x, z);
+	// If the terrain was resized then delete the old grid data
+	if (m_Grid && m_MapSize != cmpTerrain->GetTilesPerSide())
+	{
+		SAFE_DELETE(m_Grid);
+		m_TerrainDirty = true;
+	}
 
-				fixed water;
-				if (cmpWaterManager)
-					water = cmpWaterManager->GetWaterLevel(x, z);
+	// Initialise the terrain data when first needed
+	if (!m_Grid)
+	{
+		m_MapSize = cmpTerrain->GetTilesPerSide();
+		m_Grid = new Grid<NavcellData>(m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE, m_MapSize * ICmpObstructionManager::NAVCELLS_PER_TILE);
+		m_ObstructionGridDirtyID = 0;
+	}
 
-				fixed depth = water - height;
+	CmpPtr<ICmpObstructionManager> cmpObstructionManager(GetSimContext(), SYSTEM_ENTITY);
 
-				fixed slope = terrain.GetSlopeFixed(i, j);
+	bool obstructionsDirty = cmpObstructionManager->NeedUpdate(&m_ObstructionGridDirtyID);
 
-				fixed shoredist = fixed::FromInt(shoreGrid.get(i, j));
+	// TODO: for performance, it'd be nice if we could get away with not
+	// recomputing all the terrain passability when only an obstruction has
+	// changed. But that's not supported yet, so recompute everything after
+	// every change:
+	if (obstructionsDirty || m_TerrainDirty)
+	{
+		PROFILE3("UpdateGrid full");
 
-				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_PATHFINDING)
-					t |= 1;
+		// Obstructions or terrain changed - we need to recompute passability
+		// TODO: only bother recomputing the region that has actually changed
 
-				if (obstruct & ICmpObstructionManager::TILE_OBSTRUCTED_FOUNDATION)
-					t |= 2;
+		Grid<u16> shoreGrid = ComputeShoreGrid();
 
-				if (obstruct & ICmpObstructionManager::TILE_OUTOFBOUNDS)
+		ComputeTerrainPassabilityGrid(shoreGrid);
+
+		if (1) // XXX: if circular
+		{
+			PROFILE3("off-world passability");
+
+			// WARNING: CCmpRangeManager::LosIsOffWorld needs to be kept in sync with this
+			const int edgeSize = 3 * ICmpObstructionManager::NAVCELLS_PER_TILE; // number of tiles around the edge that will be off-world
+
+			NavcellData edgeMask = 0;
+			for (size_t n = 0; n < m_PassClasses.size(); ++n)
+				edgeMask |= m_PassClasses[n].m_Mask;
+
+			int w = m_Grid->m_W;
+			int h = m_Grid->m_H;
+			for (int j = 0; j < h; ++j)
+			{
+				for (int i = 0; i < w; ++i)
 				{
-					// If out of bounds, nobody is allowed to pass
-					for (size_t n = 0; n < m_PassClasses.size(); ++n)
-						t |= m_PassClasses[n].m_Mask;
-				}
-				else
-				{
-					for (size_t n = 0; n < m_PassClasses.size(); ++n)
-					{
-						if (!m_PassClasses[n].IsPassable(depth, slope, shoredist))
-							t |= m_PassClasses[n].m_Mask;
-					}
-				}
+					// Based on CCmpRangeManager::LosIsOffWorld
+					// but tweaked since it's tile-based instead.
+					// (We double all the values so we can handle half-tile coordinates.)
+					// This needs to be slightly tighter than the LOS circle,
+					// else units might get themselves lost in the SoD around the edge.
 
-				std::string moveClass = terrain.GetMovementClass(i, j);
-				if (m_TerrainCostClassTags.find(moveClass) != m_TerrainCostClassTags.end())
-					t |= COST_CLASS_MASK(m_TerrainCostClassTags[moveClass]);
+					int dist2 = (i*2 + 1 - w)*(i*2 + 1 - w)
+						+ (j*2 + 1 - h)*(j*2 + 1 - h);
 
-				m_Grid->set(i, j, t);
+					if (dist2 >= (w - 2*edgeSize) * (h - 2*edgeSize))
+						m_Grid->set(i, j, m_Grid->get(i, j) | edgeMask);
+				}
 			}
 		}
 
+		// Expand the impassability grid, for any class with non-zero clearance,
+		// so that we can stop units getting too close to impassable navcells
+		for (size_t n = 0; n < m_PassClasses.size(); ++n)
+		{
+			if (m_PassClasses[n].m_HasClearance)
+			{
+				// TODO: if multiple classes have the same clearance, we should
+				// only bother doing this once for them all
+				int clearance = (m_PassClasses[n].m_Clearance / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToInfinity();
+				if (clearance > 0)
+					ExpandImpassableCells(*m_Grid, clearance, m_PassClasses[n].m_Mask);
+			}
+		}
+
+		// Add obstructions onto the grid, for any class with (possibly zero) clearance
+		for (size_t n = 0; n < m_PassClasses.size(); ++n)
+		{
+			// TODO: if multiple classes have the same clearance, we should
+			// only bother running Rasterize once for them all
+			if (m_PassClasses[n].m_HasClearance)
+				cmpObstructionManager->Rasterize(*m_Grid, m_PassClasses[n].m_Clearance, ICmpObstructionManager::FLAG_BLOCK_PATHFINDING, m_PassClasses[n].m_Mask);
+		}
+
 		m_TerrainDirty = false;
 
 		++m_Grid->m_DirtyID;
+
+		PathfinderHierReload();
+
+		PathfinderJPSMakeDirty();
 	}
 }
 
@@ -542,14 +568,14 @@
 
 // Async path requests:
 
-u32 CCmpPathfinder::ComputePathAsync(entity_pos_t x0, entity_pos_t z0, const Goal& goal, pass_class_t passClass, cost_class_t costClass, entity_id_t notify)
+u32 CCmpPathfinder::ComputePathAsync(entity_pos_t x0, entity_pos_t z0, const PathGoal& goal, pass_class_t passClass, entity_id_t notify)
 {
-	AsyncLongPathRequest req = { m_NextAsyncTicket++, x0, z0, goal, passClass, costClass, notify };
+	AsyncLongPathRequest req = { m_NextAsyncTicket++, x0, z0, goal, passClass, notify };
 	m_AsyncLongPathRequests.push_back(req);
 	return req.ticket;
 }
 
-u32 CCmpPathfinder::ComputeShortPathAsync(entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const Goal& goal, pass_class_t passClass, bool avoidMovingUnits, entity_id_t group, entity_id_t notify)
+u32 CCmpPathfinder::ComputeShortPathAsync(entity_pos_t x0, entity_pos_t z0, entity_pos_t r, entity_pos_t range, const PathGoal& goal, pass_class_t passClass, bool avoidMovingUnits, entity_id_t group, entity_id_t notify)
 {
 	AsyncShortPathRequest req = { m_NextAsyncTicket++, x0, z0, r, range, goal, passClass, avoidMovingUnits, group, notify };
 	m_AsyncShortPathRequests.push_back(req);
@@ -580,7 +606,11 @@
 	{
 		const AsyncLongPathRequest& req = longRequests[i];
 		Path path;
-		ComputePath(req.x0, req.z0, req.goal, req.passClass, req.costClass, path);
+#if PATHFIND_USE_JPS
+		ComputePathJPS(req.x0, req.z0, req.goal, req.passClass, path);
+#else
+		ComputePath(req.x0, req.z0, req.goal, req.passClass, path);
+#endif
 		CMessagePathResult msg(req.ticket, path);
 		GetSimContext().GetComponentManager().PostMessage(req.notify, msg);
 	}
@@ -656,6 +686,8 @@
 	}
 }
 
+//////////////////////////////////////////////////////////
+
 bool CCmpPathfinder::CheckUnitPlacement(const IObstructionTestFilter& filter,
 	entity_pos_t x, entity_pos_t z, entity_pos_t r,	pass_class_t passClass)
 {
@@ -667,23 +699,19 @@
 	if (cmpObstructionManager->TestUnitShape(filter, x, z, r, NULL))
 		return false;
 
-	// Test against terrain:
+	// Test against terrain and static obstructions:
 
 	UpdateGrid();
 
-	u16 i0, j0, i1, j1;
-	NearestTile(x - r, z - r, i0, j0);
-	NearestTile(x + r, z + r, i1, j1);
-	for (u16 j = j0; j <= j1; ++j)
-	{
-		for (u16 i = i0; i <= i1; ++i)
-		{
-			if (!IS_TERRAIN_PASSABLE(m_Grid->get(i,j), passClass))
-			{
-				return false;
-			}
-		}
-	}
+	u16 i, j;
+	NearestNavcell(x, z, i, j);
+	if (!IS_PASSABLE(m_Grid->get(i, j), passClass))
+		return false;
+
+	// (Static obstructions will be redundantly tested against in both the
+	// obstruction-shape test and navcell-passability test, which is slightly
+	// inefficient but shouldn't affect behaviour)
+
 	return true;
 }
 
@@ -711,27 +739,96 @@
 	if (!cmpObstruction->GetObstructionSquare(square))
 		return false;
 
-	// Expand bounds by 1/sqrt(2) tile (multiply by TERRAIN_TILE_SIZE since we want world coordinates)
-	entity_pos_t expand = entity_pos_t::FromInt(2).Sqrt().Multiply(entity_pos_t::FromInt(TERRAIN_TILE_SIZE / 2));
-	CFixedVector2D halfSize(square.hw + expand, square.hh + expand);
-	CFixedVector2D halfBound = Geometry::GetHalfBoundingBox(square.u, square.v, halfSize);
+	entity_pos_t expand;
+	const PathfinderPassability* passability = GetPassabilityFromMask(passClass);
+	if (passability && passability->m_HasClearance)
+		expand = passability->m_Clearance;
 
-	u16 i0, j0, i1, j1;
-	NearestTile(square.x - halfBound.X, square.z - halfBound.Y, i0, j0);
-	NearestTile(square.x + halfBound.X, square.z + halfBound.Y, i1, j1);
-	for (u16 j = j0; j <= j1; ++j)
+	SimRasterize::Spans spans;
+	SimRasterize::RasterizeRectWithClearance(spans, square, expand, ICmpObstructionManager::NAVCELL_SIZE);
+	for (size_t k = 0; k < spans.size(); ++k)
 	{
-		for (u16 i = i0; i <= i1; ++i)
+		i16 i0 = spans[k].i0;
+		i16 i1 = spans[k].i1;
+		i16 j = spans[k].j;
+
+		// Fail if any span extends outside the grid
+		if (i0 < 0 || i1 > m_Grid->m_W || j < 0 || j > m_Grid->m_H)
+			return false;
+
+		// Fail if any span includes an impassable tile
+		for (i16 i = i0; i < i1; ++i)
+			if (!IS_PASSABLE(m_Grid->get(i, j), passClass))
+				return false;
+	}
+
+	return true;
+}
+
+//////////////////////////////////////////////////////////
+
+void CCmpPathfinder::ComputePathOffImpassable(u16 i0, u16 j0, pass_class_t passClass, Path& path)
+{
+	u16 iGoal = i0;
+	u16 jGoal = j0;
+	this->PathfinderHierFindNearestPassableNavcell(iGoal, jGoal, passClass);
+
+	int ip = iGoal;
+	int jp = jGoal;
+
+	// Reconstruct the path (in reverse)
+	while (ip != i0 || jp != j0)
+	{
+		entity_pos_t x, z;
+		NavcellCenter(ip, jp, x, z);
+		Waypoint w = { x, z };
+		path.m_Waypoints.push_back(w);
+
+		// Move diagonally/horizontally/vertically towards the start navcell
+
+		if (ip > i0)
+			ip--;
+		else if (ip < i0)
+			ip++;
+
+		if (jp > j0)
+			jp--;
+		else if (jp < j0)
+			jp++;
+	}
+}
+
+void CCmpPathfinder::NormalizePathWaypoints(Path& path)
+{
+	if (path.m_Waypoints.empty())
+		return;
+
+	// Given the current list of waypoints, add intermediate waypoints
+	// in a straight line between them, so that the maximum gap between
+	// waypoints is within the (fairly arbitrary) limit
+	const fixed MAX_WAYPOINT_SEPARATION = ICmpObstructionManager::NAVCELL_SIZE * 4;
+
+	std::vector<Waypoint>& waypoints = path.m_Waypoints;
+	std::vector<Waypoint> newWaypoints;
+
+	newWaypoints.push_back(waypoints.front());
+	for (size_t k = 1; k < waypoints.size(); ++k)
+	{
+		CFixedVector2D prev(waypoints[k-1].x, waypoints[k-1].z);
+		CFixedVector2D curr(waypoints[k].x, waypoints[k].z);
+		fixed dist = (curr - prev).Length();
+		if (dist > MAX_WAYPOINT_SEPARATION)
 		{
-			entity_pos_t x, z;
-			TileCenter(i, j, x, z);
-			if (Geometry::PointIsInSquare(CFixedVector2D(x - square.x, z - square.z), square.u, square.v, halfSize)
-				&& !IS_TERRAIN_PASSABLE(m_Grid->get(i,j), passClass))
+			int segments = (dist / MAX_WAYPOINT_SEPARATION).ToInt_RoundToInfinity();
+			for (int i = 1; i < segments; ++i)
 			{
-				return false;
+				CFixedVector2D p = prev + ((curr - prev)*i) / segments;
+				Waypoint wp = { p.X, p.Y };
+				newWaypoints.push_back(wp);
 			}
 		}
+		newWaypoints.push_back(waypoints[k]);
 	}
 
-	return true;
+	path.m_Waypoints.swap(newWaypoints);
 }
